From 13ec99cc56db23c4415f6f8bbb05f3b2e830a4d4 Mon Sep 17 00:00:00 2001
From: Sricharan R <sricharan@codeaurora.org>
Date: Fri, 9 Nov 2018 20:01:06 +0530
Subject: [PATCH 11/25] TEMP: NOT FOR REVIEW: qclib: Add qclib support

Add to load and execute qclib blob to configure pmic,
clocks and ddr. This is the basic support without
one-training and interface table to pass data
between coreboot and qclib. That would be added later.

Change-Id: I534af71163d034ea04420dda6a94ce31b08c8a07
Signed-off-by: Nitheesh Sekar <nsekar@codeaurora.org>
Signed-off-by: Sricharan R <sricharan@codeaurora.org>
---
 src/mainboard/google/mistral/Makefile.inc        |  1 +
 src/mainboard/google/mistral/romstage.c          |  3 +
 src/soc/qualcomm/qcs405/Makefile.inc             | 24 ++++++
 src/soc/qualcomm/qcs405/include/soc/memlayout.ld |  2 +
 src/soc/qualcomm/qcs405/include/soc/mmu.h        |  1 +
 src/soc/qualcomm/qcs405/include/soc/qclib.h      | 21 ++++++
 src/soc/qualcomm/qcs405/include/soc/symbols.h    |  2 +
 src/soc/qualcomm/qcs405/mmu.c                    |  7 ++
 src/soc/qualcomm/qcs405/qclib_execute.c          | 93 ++++++++++++++++++++++++
 9 files changed, 154 insertions(+)
 create mode 100644 src/soc/qualcomm/qcs405/include/soc/qclib.h
 create mode 100644 src/soc/qualcomm/qcs405/qclib_execute.c

diff --git a/src/mainboard/google/mistral/Makefile.inc b/src/mainboard/google/mistral/Makefile.inc
index ca191d147e0b..fcfed7dfe1f0 100644
--- a/src/mainboard/google/mistral/Makefile.inc
+++ b/src/mainboard/google/mistral/Makefile.inc
@@ -13,6 +13,7 @@ romstage-y += memlayout.ld
 romstage-y += chromeos.c
 romstage-y += reset.c
 romstage-y += romstage.c
+romstage-y += romstage.c
 
 ramstage-y += memlayout.ld
 ramstage-y += chromeos.c
diff --git a/src/mainboard/google/mistral/romstage.c b/src/mainboard/google/mistral/romstage.c
index 41ee4edcbb1c..bce258df9d0a 100644
--- a/src/mainboard/google/mistral/romstage.c
+++ b/src/mainboard/google/mistral/romstage.c
@@ -14,6 +14,7 @@
  */
 
 #include <arch/stages.h>
+#include <soc/qclib.h>
 #include <soc/usb.h>
 
 static void prepare_usb(void)
@@ -27,5 +28,7 @@ static void prepare_usb(void)
 
 void platform_romstage_main(void)
 {
+	/* QCLib: DDR init & train */
+	qclib_load_and_run();
 	prepare_usb();
 }
diff --git a/src/soc/qualcomm/qcs405/Makefile.inc b/src/soc/qualcomm/qcs405/Makefile.inc
index c64e5bcf5804..4628a53908ef 100644
--- a/src/soc/qualcomm/qcs405/Makefile.inc
+++ b/src/soc/qualcomm/qcs405/Makefile.inc
@@ -25,6 +25,8 @@ romstage-y += gpio.c
 romstage-y += clock.c
 romstage-y += usb.c
 romstage-$(CONFIG_DRIVERS_UART) += uart.c
+romstage-y += mmu.c
+romstage-y += qclib_execute.c
 
 ################################################################################
 ramstage-y += soc.c
@@ -44,4 +46,26 @@ $(objcbfs)/bootblock.bin: $(objcbfs)/bootblock.raw.bin
 	@printf "Generating: $(subst $(obj)/,,$(@))\n"
 	cp $(objcbfs)/bootblock.raw.bin $(objcbfs)/bootblock.bin
 
+################################################################################
+QCLIB_FILE := $(QCS405_BLOB)/QcLib.elf
+qclib_file := $(shell ls $(QCLIB_FILE))
+ifneq (,$(findstring $(QCLIB_FILE),$(qclib_file)))
+	QCLIB_CBFS := $(CONFIG_CBFS_PREFIX)/qclib
+	$(QCLIB_CBFS)-file := $(QCLIB_FILE)
+	$(QCLIB_CBFS)-type := stage
+	$(QCLIB_CBFS)-compression := none
+	cbfs-files-y += $(QCLIB_CBFS)
+endif
+
+################################################################################
+PMIC_FILE := $(QCS405_BLOB)/pmic.elf
+pmic_file := $(shell ls $(PMIC_FILE))
+ifneq (,$(findstring $(PMIC_FILE),$(pmic_file)))
+	PMIC_CBFS := $(CONFIG_CBFS_PREFIX)/pmiccfg
+	$(PMIC_CBFS)-file := $(PMIC_FILE)
+	$(PMIC_CBFS)-type := stage
+	$(PMIC_CBFS)-compression := none
+	cbfs-files-y += $(PMIC_CBFS)
+endif
+
 endif
diff --git a/src/soc/qualcomm/qcs405/include/soc/memlayout.ld b/src/soc/qualcomm/qcs405/include/soc/memlayout.ld
index f9ca7888f2ae..506433011675 100644
--- a/src/soc/qualcomm/qcs405/include/soc/memlayout.ld
+++ b/src/soc/qualcomm/qcs405/include/soc/memlayout.ld
@@ -39,6 +39,8 @@ SECTIONS
 	TIMESTAMP(0x8C50000, 1K)
 	PRERAM_CBMEM_CONSOLE(0x8C50400, 32K)
 	PRERAM_CBFS_CACHE(0x8C58400, 70K)
+	REGION(qclib, 0x8C6a000, 0x80000, 4096)
+	REGION(pmic, 0x8CED000, 0x10000, 4096)
 	BSRAM_END(0x8D80000)
 
 	DRAM_START(0x80000000)
diff --git a/src/soc/qualcomm/qcs405/include/soc/mmu.h b/src/soc/qualcomm/qcs405/include/soc/mmu.h
index bc42e7271ad4..853505b6ccad 100644
--- a/src/soc/qualcomm/qcs405/include/soc/mmu.h
+++ b/src/soc/qualcomm/qcs405/include/soc/mmu.h
@@ -17,5 +17,6 @@
 #define _SOC_QUALCOMM_QCS405_MMU_H__
 
 void qcs405_mmu_init(void);
+void qcs405_mmu_dram_config_c(void);
 
 #endif  // _SOC_QUALCOMM_QCS405_MMU_H_
diff --git a/src/soc/qualcomm/qcs405/include/soc/qclib.h b/src/soc/qualcomm/qcs405/include/soc/qclib.h
new file mode 100644
index 000000000000..66fc6128fae7
--- /dev/null
+++ b/src/soc/qualcomm/qcs405/include/soc/qclib.h
@@ -0,0 +1,21 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2018, The Linux Foundation.  All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef _SOC_QUALCOMM_QCS405_QCLIB_H__
+#define _SOC_QUALCOMM_QCS405_QCLIB_H__
+
+void qclib_load_and_run(void);
+
+#endif  // _SOC_QUALCOMM_QCS405_QCLIB_H_
diff --git a/src/soc/qualcomm/qcs405/include/soc/symbols.h b/src/soc/qualcomm/qcs405/include/soc/symbols.h
index 45e6988683c1..ab5bdcb1ff08 100644
--- a/src/soc/qualcomm/qcs405/include/soc/symbols.h
+++ b/src/soc/qualcomm/qcs405/include/soc/symbols.h
@@ -22,5 +22,7 @@
 DECLARE_REGION(ssram);
 DECLARE_REGION(bsram);
 DECLARE_REGION(dram_reserved);
+DECLARE_REGION(dcb);
+DECLARE_REGION(pmic);
 
 #endif // _SOC_QUALCOMM_QCS405_SYMBOLS_H_
diff --git a/src/soc/qualcomm/qcs405/mmu.c b/src/soc/qualcomm/qcs405/mmu.c
index a2d626fd3561..7da3bb002d5a 100644
--- a/src/soc/qualcomm/qcs405/mmu.c
+++ b/src/soc/qualcomm/qcs405/mmu.c
@@ -27,6 +27,13 @@ void qcs405_mmu_init(void)
 			MA_DEV | MA_S | MA_RW);
 	mmu_config_range((void *)_ssram, REGION_SIZE(ssram), MA_MEM | MA_S | MA_RW);
 	mmu_config_range((void *)_bsram, REGION_SIZE(bsram), MA_MEM | MA_S | MA_RW);
+	mmu_config_range((void *)0x80000000, 0x40000000, MA_MEM | MA_S | MA_RW);
 
 	mmu_enable();
 }
+
+void qcs405_mmu_dram_config_c(void)
+{
+	mmu_config_range((void *)0x80000000, 0x40000000,
+			 MA_MEM | MA_NS | MA_RW);
+}
diff --git a/src/soc/qualcomm/qcs405/qclib_execute.c b/src/soc/qualcomm/qcs405/qclib_execute.c
new file mode 100644
index 000000000000..afcd260ed334
--- /dev/null
+++ b/src/soc/qualcomm/qcs405/qclib_execute.c
@@ -0,0 +1,93 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2018, The Linux Foundation.  All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <string.h>
+#include <arch/cache.h>
+#include <arch/mmu.h>
+#include <cbfs.h>
+#include <halt.h>
+#include <console/console.h>
+#include <timestamp.h>
+#include <soc/mmu.h>
+#include <soc/qclib.h>
+#include <soc/symbols.h>
+
+#define PMIC_NAME "/pmiccfg"
+#define DCB_NAME  "/dcb"
+#define QCLIB_NAME "/qclib"
+
+#define PBL_DATA_PTR 0x8c101a0
+
+void qclib_load_and_run(void)
+{
+	int (*doit)(void *entry, void *iftbl);
+	void *arg;
+	int ret_code;
+	struct mmu_context pre_qclib_mmu_context;
+
+	struct prog qclib =
+		PROG_INIT(PROG_REFCODE, CONFIG_CBFS_PREFIX QCLIB_NAME);
+
+	struct prog pmic =
+		PROG_INIT(PROG_REFCODE, CONFIG_CBFS_PREFIX PMIC_NAME);
+
+	/* Attempt to load PMICCFG Blob */
+	if (prog_locate(&pmic))
+		goto fail;
+
+	if (cbfs_prog_stage_load(&pmic))
+		goto fail;
+
+	/* Attempt to load QCLib elf */
+	if (prog_locate(&qclib))
+		goto fail;
+
+	if (cbfs_prog_stage_load(&qclib))
+		goto fail;
+
+	prog_set_entry(&qclib, qclib.entry, (void *)PBL_DATA_PTR);
+
+	printk(BIOS_DEBUG, "\n\n\nQCLib is about to Initialize PMIC and DDR\n");
+	printk(BIOS_DEBUG, "Jumping to QCLib code at %p(%p)\n",
+	       prog_entry(&qclib), prog_entry_arg(&qclib));
+
+	doit = prog_entry(&qclib);
+	arg = prog_entry_arg(&qclib);
+
+	/* back-up mmu context before disabling mmu and executing qclib */
+	mmu_save_context(&pre_qclib_mmu_context);
+	/*
+	 * Disable mmu before jumping to qclib. mmu_disable also
+	 * flushes and invalidates caches before disabling mmu.
+	 */
+	mmu_disable();
+
+	ret_code = doit(arg, NULL);
+	printk(BIOS_DEBUG, "QCLib completed\n\n\n");
+
+	/* Before returning, QCLib flushes cache and disables mmu.
+	 * Explicitly disable mmu (flush, invalidate and disable mmu)
+	 * before re-enabling mmu with backed-up mmu context
+	 */
+	mmu_disable();
+	mmu_restore_context(&pre_qclib_mmu_context);
+	mmu_enable();
+
+	qcs405_mmu_dram_config_c();
+	return;
+
+fail:
+	die("Couldn't run QCLib.\n");
+}
-- 
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora Forum,
a Linux Foundation Collaborative Project

